from xml.sax import parse
from xml.sax.handler import ContentHandler

'''--- 试验 ---'''

# class XMLHandler(ContentHandler):
#     def startElement(self, name, attrs):  # 重写startElement方法
#         print(name, list(zip(attrs.keys(), attrs.values())))  # 显示输出参数内容
#
# parse('website.xml', XMLHandler())  # 调用解析函数


'''--- 提取所有的一级标题 ---'''


class HeadLineHandler(ContentHandler):
    def __init__(self, headLines):
        super().__init__()  # 不写对结果也没有影响
        self.headLines = headLines  # 初始化类的变量为传入的标题列表
        self.in_headLine = False  # 初始化开关变量
        self.data = []  # 初始化临时保存数据的变量

    def startElement(self, name, attrs):  # 重写开始元素的方法
        if name == 'h1':  # 如果是一级标题开始标记
            self.in_headLine = True  # 打开开关

    def characters(self, content):  # 重写元素内容的方法
        if self.in_headLine:  # 如果开关打开
            self.data.append(content)  # 添加内容到临时变量

    def endElement(self, name):  # 重写结束元素的方法
        if name == 'h1':  # 如果是一级标题结束标记
            content = ''.join(self.data)  # 提取内容为临时变量中保存的所有内容
            self.data = []  # 清空临时变量
            self.headLines.append(content)  # 标题列表中添加提取到的内容
            self.in_headLine = False  # 关闭开关


if __name__ == '__main__':
    headLines = []  # 创建空的一级标题列表
    parse('website.xml', HeadLineHandler(headLines))  # 调用解析方法
    for line in headLines:  # 遍历通过解析写入内容的一级标题列表
        print(line)  # 显示输出每一个标题内容
