from  xml.sax import parse
from xml.sax.handler import ContentHandler


class MakePages(ContentHandler):
    in_page = False  # 定义开关变量

    def startElement(self, name, attrs):  # 重写开始元素的方法
        if name == 'page':  # 如果是页面标记
            self.in_page = True  # 打开开关
            self.file = open(attrs['name'] + '.html', 'w')  # 创建HTML文件
            self.file.write('<html>\n<head>\n<meta charset="gbk">\n<title>{}</title>\n</head>\n<body>\n'
                            .format(attrs['title']))  # 写入页头HTML代码
        elif self.in_page:  # 如果开关被打开
            self.file.write('<' + name)  # 写入标记开始符号与名称
            for key, value in attrs.items():  # 遍历属性集合
                self.file.write(' {}="{}"'.format(key, value))  # 写入属性的键值
            self.file.write('>')  # 写入标记末尾符号

    def characters(self, content):  # 重写元素内容的方法
        if self.in_page:  # 如果开关被打开
            self.file.write(content)  # 写入内容

    def endElement(self, name):  # 重写结束元素的方法
        if name == 'page':  # 如果是页面标记
            self.in_page = False  # 关闭开关
            self.file.write('\n</body>\n</html>\n')  # 写入页脚HTML代码
            self.file.close()  # 关闭创建的页面文件
        elif self.in_page:  # 如果开关被打开
            self.file.write('</' + name + '>')  # 写入结束标记


if __name__ == '__main__':
    parse('website.xml', MakePages())  # 调用解析函数
